Package picard.illumina

## Class NewIlluminaBasecallsConverter<CLUSTER_OUTPUT_RECORD>

- java.lang.Object
- - picard.illumina.NewIlluminaBasecallsConverter<CLUSTER_OUTPUT_RECORD>

-     public class NewIlluminaBasecallsConverter<CLUSTER_OUTPUT_RECORD>
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected BclQualityEvaluationStrategy` | `bclQualityEvaluationStrategy` |
    `protected IlluminaDataProviderFactory` | `factory` |
    `static Comparator<Integer>` | `TILE_NUMBER_COMPARATOR` | A comparator for tile numbers, which are not necessarily ordered by the number's value.
    `protected List<Integer>` | `tiles` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---

    `NewIlluminaBasecallsConverter​(File basecallsDir, File barcodesDir, int lane, ReadStructure readStructure, Map<String,​? extends picard.illumina.BasecallsConverter.ConvertedClusterDataWriter<CLUSTER_OUTPUT_RECORD>> barcodeRecordWriterMap, boolean demultiplex, int maxReadsInRamPerTile, List<File> tmpDirs, int numProcessors, Integer firstTile, Integer tileLimit, Comparator<CLUSTER_OUTPUT_RECORD> outputRecordComparator, htsjdk.samtools.util.SortingCollection.Codec<CLUSTER_OUTPUT_RECORD> codecPrototype, Class<CLUSTER_OUTPUT_RECORD> outputRecordClass, BclQualityEvaluationStrategy bclQualityEvaluationStrategy, boolean ignoreUnexpectedBarcodes)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `doTileProcessing()` |
    `IlluminaDataProviderFactory` | `getFactory()` |
    `static File[]` | `getTiledFiles​(File baseDirectory, Pattern pattern)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### bclQualityEvaluationStrategy

          protected final BclQualityEvaluationStrategy bclQualityEvaluationStrategy

    - #### tiles

          protected List<Integer> tiles

    - #### factory

          protected final IlluminaDataProviderFactory factory

    - #### TILE_NUMBER_COMPARATOR

          public static final Comparator<Integer> TILE_NUMBER_COMPARATOR

      A comparator for tile numbers, which are not necessarily ordered by the number's value.

  - ### Constructor Detail

    - #### NewIlluminaBasecallsConverter

          public NewIlluminaBasecallsConverter​(File basecallsDir,
                                               File barcodesDir,
                                               int lane,
                                               ReadStructure readStructure,
                                               Map<String,​? extends picard.illumina.BasecallsConverter.ConvertedClusterDataWriter<CLUSTER_OUTPUT_RECORD>> barcodeRecordWriterMap,
                                               boolean demultiplex,
                                               int maxReadsInRamPerTile,
                                               List<File> tmpDirs,
                                               int numProcessors,
                                               Integer firstTile,
                                               Integer tileLimit,
                                               Comparator<CLUSTER_OUTPUT_RECORD> outputRecordComparator,
                                               htsjdk.samtools.util.SortingCollection.Codec<CLUSTER_OUTPUT_RECORD> codecPrototype,
                                               Class<CLUSTER_OUTPUT_RECORD> outputRecordClass,
                                               BclQualityEvaluationStrategy bclQualityEvaluationStrategy,
                                               boolean ignoreUnexpectedBarcodes)

      Parameters:
        `basecallsDir` - Where to read basecalls from.
        `barcodesDir` - Where to read barcodes from (optional; use basecallsDir if not specified).
        `lane` - What lane to process.
        `readStructure` - How to interpret each cluster.
        `barcodeRecordWriterMap` - Map from barcode to CLUSTER_OUTPUT_RECORD writer. If demultiplex is false, must contain one writer stored with key=null.
        `demultiplex` - If true, output is split by barcode, otherwise all are written to the same output stream.
        `maxReadsInRamPerTile` - Configures number of reads each tile will store in RAM before spilling to disk.
        `tmpDirs` - For SortingCollection spilling.
        `numProcessors` - Controls number of threads. If <= 0, the number of threads allocated is available cores - numProcessors.
        `firstTile` - (For debugging) If non-null, start processing at this tile.
        `tileLimit` - (For debugging) If non-null, process no more than this many tiles.
        `outputRecordComparator` - For sorting output records within a single tile.
        `codecPrototype` - For spilling output records to disk.
        `outputRecordClass` - Inconveniently needed to create SortingCollections.
        `ignoreUnexpectedBarcodes` - If true, will ignore reads whose called barcode is not found in barcodeRecordWriterMap,

  - ### Method Detail

    - #### getTiledFiles

          public static File[] getTiledFiles​(File baseDirectory,
                                             Pattern pattern)

    - #### doTileProcessing

          public void doTileProcessing()

    - #### getFactory

          public IlluminaDataProviderFactory getFactory()